//+------------------------------------------------------------------+
//|                                               Spread Monitor.mq4 |
//|                                           Copyright  2008 Wolfe |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008 Wolfe"
#property link      ""

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Cornsilk
#property indicator_color2 Red
#property indicator_color3 Blue

extern string Pair = "EURUSD";
extern double Normal_Spread = 2;
extern bool   Play_Alert = true;
extern bool   Print_To_Journal=true;

int Widen_Count;

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
int tik,t;
   double buf[],buf2[],MaxB,MinB=1000;
int period=1000;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexLabel(0,NULL);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexLabel(1,"Spread");
   SetIndexStyle(2,DRAW_NONE);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexLabel(2,NULL);
   
   
   if (Pair != Symbol())
    {
     Alert("PAIR DOES NOT = CHART!  **RESET PAIR**");
    }
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
  double CurrentSpread = MarketInfo(Pair,MODE_SPREAD);
  
  IndicatorShortName("SPREAD MONITOR  Current Spread =" );
  
  if (Pair != Symbol())
    {
     Alert("PAIR DOES NOT = CHART! ",Symbol(),"  **RESET PAIR**");
    }
    
   int i,b;
//---- 
t++;
b=period;
ArrayResize(buf,b);
ArrayResize(buf2,b);

if(tik==0)
   {
   for(i=0;i<b;i++)
      {
      buf[i]=0;
      buf2[i]=CurrentSpread;
      }
   ExtMapBuffer3[0]=10;   
   ExtMapBuffer3[1]=10;   
   tik=1;
   }
   MaxB=0;MinB=1000;
   for(i=b-1;i>0;i--)
      {
      buf[i]=buf[i-1];
      if(MaxB<buf[i])MaxB=buf[i];
      if(MinB>buf[i])MinB=buf[i];
      } 
    for(i=b-1;i>0;i--)
      {
      buf2[i]=buf2[i-1];
      if(MaxB<buf2[i])MaxB=buf2[i];
      if(MinB>buf2[i])MinB=buf2[i];
      } 
buf[0]=0;
for(i=0;i<b;i++)
   {
   ExtMapBuffer1[i]=buf[i];
   }
buf2[0]=CurrentSpread;
for(i=0;i<b;i++)
   {
   ExtMapBuffer2[i]=buf2[i];
   }
if(MathCeil(t/10)*10==t)
   {
   for(i=b;i<Bars;i++)
      {
      ExtMapBuffer1[i]=0;
      ExtMapBuffer2[i]=CurrentSpread;
      }
      ArrayInitialize(ExtMapBuffer3,0); 
      if(MaxB<10)ExtMapBuffer3[0]=10;
      if(MinB<10)ExtMapBuffer3[1]=10;
      //Print(MaxB,"+",Bid,"+",MinB);
   }
   
   
   
   if (CurrentSpread > Normal_Spread)
    {
     Widen_Count++;
      {
       if (Play_Alert == true)
        {
         PlaySound("alert2.wav");
        }
       if (Print_To_Journal==true)
        {
         Print("                      !!!!!!SPREAD WIDENED!!!!!!  Normal Spread = ",Normal_Spread,"  Current Spread = ",
         MarketInfo(Pair,MODE_SPREAD),"    ",Symbol());
        } 
      }
    } 
   
    Comment("Normal Spread ",Pair," =",Normal_Spread,
         "\nCurrent Spread ",Pair," =",CurrentSpread,
         "\nWiden Count = ",Widen_Count);
//----
   return(0);
  }
//+------------------------------------------------------------------+